<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 12/08/13
 * Time: 13:48
 * To change this template use File | Settings | File Templates.
 */

namespace BancoTalentos\Logic\Cadastros;


use Folha\Entities\GpePessoa;
use Folha\Entities\GpePessoah;
use Geral\Util\DateUtil;
use Controller\ValoresDefault;

class Pessoa {

    /** @var  $pessoa \Folha\Entities\GpePessoa */
    private $pessoa;
    /** @var  $pessoah \Folha\Entities\GpePessoah */
    private $pessoah;

    public function novaPessoa($nrorg, $nrparcnegocio, $dtmescompetencia, $nmpessoa, $primeiroNome, $meioNome,
                               $ultimoNome, $dtNascimento, $idSexo, $nrCPF, $cdEstadoCivil, $cdpais,
                               $sgEstado, $cdMunicipio,$nrNacionalidade, $grauinstrucao, $idpossuifilho)
    {
        $this->pessoa = new GpePessoa();
        $this->pessoah = new GpePessoah();
        $this->novaPessoaMestre($nrparcnegocio, $nrorg);
        $this->novaPessoaHistorico(
            $nrorg, $this->pessoa->getNrpessoa(), $dtmescompetencia, $nmpessoa, $primeiroNome, $meioNome,
            $ultimoNome, $dtNascimento, $idSexo, $nrCPF, $cdEstadoCivil, $cdpais,
            $sgEstado, $cdMunicipio, $nrNacionalidade, $grauinstrucao, $idpossuifilho);
        return $this->pessoa->getNrpessoa();
    }

    private function novaPessoaMestre($nrparcnegocio, $nrorg) {

        $this->pessoa->setNrorg($nrorg);
        $this->pessoa->setNrparcnegocio($nrparcnegocio);
        $this->pessoa->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
        $this->pessoa->setNrpessoa(\Geral\Util\NovoCodigo::geraCodigo($nrorg, 'GPE_PESSOA', 1, 12, true));
        //$this->pessoa->beforeInsertPessoa();

        $this->pessoa->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    public function novaPessoaHistorico(
        $nrorg, $nrpessoa, $dtmescompetencia, $nmpessoa, $primeiroNome, $meioNome, $ultimoNome, $dtNascimento, $idSexo,
        $nrCPF, $cdEstadoCivil, $cdpais, $sgEstado, $cdMunicipio,$nrNacionalidade, $grauinstrucao, $idpossuifilho)
    {   

        $valorDefault = new ValoresDefault();
        $apelido = $valorDefault->getApelidoPadrao();
        $pronomeTratamento = $valorDefault->getPronomeTratamentoPadrao();
        $nrCertidaoNascimento = $valorDefault->getNrCertidaoPadrao();

        $this->setDadosPrincipais(
            $nrpessoa, $nmpessoa, $primeiroNome, $meioNome, $ultimoNome, $apelido, $dtmescompetencia,
            $pronomeTratamento, $dtNascimento, $nrCertidaoNascimento, $grauinstrucao, $idpossuifilho
        );

        $this->setRegistroIdentidade($nrCPF, null, null, null, null, null);

        $this->setLocal($cdpais, $sgEstado, $cdMunicipio, $nrNacionalidade);

        //$this->setDadosCarteiraTrabalho($nrCTPS, $nrSerieCTPS, $sgufCTPS, $dtCTPS);
        //$this->setDadosImpostos($nrPIS, $dtPIS, $nrInscricaoINSS, $nrInscricaoISS);
        $this->setDadosCivis($cdEstadoCivil, null, null);        
        //$this->setDadosEleitorais($idIsentoTituloEleitor, $nrTituloEleitor, $nrSecaoEleitoral, $nrZonaEleitoral);
        //$this->setDadosHabilitacaoVeiculo($nrHabilitacao, $dtHabilitacao, $dtValidadeHabilitacao, $categoriaHabilitacao);
        /*$this->setDadosMilitares(
            $nrCategoriaMilitar, $nrCertificadoReservista, $dsCertificadoReservista, $dtCertificadoReservista,
            $cdExpedicaoCertificadoReservista
        );*/
        $this->setDadosFisicos($idSexo, null, null, null, null);
        $this->setDadosAdicionais($grauinstrucao);

        $this->pessoah->setNrorg($nrorg);
        $this->pessoah->setNrpessoah(\Geral\Util\NovoCodigo::geraCodigo($nrorg, 'GPE_PESSOAH', 1, 12, true));

        //$this->pessoah->beforeInsertPessoah();
        $this->pessoah->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
    }

    private function setDadosPrincipais($nrpessoa, $nmpessoa, $primeiroNome, $meioNome, $ultimoNome, $apelido, $dtmescompetencia,
                                        $pronomeTratamento, $dtNascimento, $nrCertidaoNascimento, $grauinstrucao, $idpossuifilho)
    {
        $this->pessoah->setNrpessoa($nrpessoa);
        $this->pessoah->setNmpessoa($nmpessoa);
        $this->pessoah->setDsprinomepess($primeiroNome);
        $this->pessoah->setDsnomemeiopess($meioNome);
        $this->pessoah->setDsultnomepess($ultimoNome);
        $this->pessoah->setDsapelidopess($apelido);
        $this->pessoah->setDspronometrat($pronomeTratamento);
        $this->pessoah->setNrcertnascpes($nrCertidaoNascimento);
        $this->pessoah->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
        $this->pessoah->setIdpossuifilho($idpossuifilho);

        if (!($dtmescompetencia instanceof \DateTime)) {
            $this->pessoah->setDtmescompetenc(DateUtil::getDataDeString($dtmescompetencia, DateUtil::FORMATO_BRASILEIRO, true));
        } else {
            $this->pessoah->setDtmescompetenc($dtmescompetencia);
        }

        if (!($dtNascimento instanceof \DateTime)) {
            $this->pessoah->setDtnascpessoa(DateUtil::getDataDeString($dtNascimento));
        } else {
             $this->pessoah->setDtnascpessoa($dtNascimento);
        }

    }

    private function setRegistroIdentidade($nrCPF, $nrRg, $orgaoExpedidorRG, $sgExpedidorRG, $dsLocalExpedicaoRG,
                                           $dtExpedicaoRG)
    {
        $this->pessoah->setNrcpfpessoa($nrCPF);
        $this->pessoah->setNrrgpessoa($nrRg);
        $this->pessoah->setCdexrgpessoa($orgaoExpedidorRG);
        $this->pessoah->setSgufrgpessoa($sgExpedidorRG);
        $this->pessoah->setDslocalexrgpes($dsLocalExpedicaoRG);

        if (!($dtExpedicaoRG instanceof \DateTime)) {
            $this->pessoah->setDtexrgpessoa(DateUtil::getDataDeString($dtExpedicaoRG));
        }
    }

    /**
     * @param $cdpais
     * @param $sgEstado
     * @param $cdMunicipio
     * @param $nrNacionalidade
     */
    private function setLocal($cdpais, $sgEstado, $cdMunicipio, $nrNacionalidade)
    {
        $this->pessoah->setNrnacionalid($nrNacionalidade);
        $this->pessoah->setCdpais($cdpais);
        $this->pessoah->setSgestado($sgEstado);
        $this->pessoah->setCdmunicipio($cdMunicipio);
    }

    /**
     * @param $nrCTPS
     * @param $nrSerieCTPS
     * @param $sgufCTPS
     * @param $dtCTPS
     */
    private function setDadosCarteiraTrabalho($nrCTPS, $nrSerieCTPS, $sgufCTPS, $dtCTPS)
    {
        $this->pessoah->setNrctpspessoa($nrCTPS);
        $this->pessoah->setNrseriectpspes($nrSerieCTPS);
        $this->pessoah->setSgufctpspes($sgufCTPS);

        if (!($dtCTPS instanceof \DateTime)) {
            $this->pessoah->setDtctpspessoa(DateUtil::getDataDeString($dtCTPS));
        }
    }

    /**
     * @param $nrPIS
     * @param $dtPIS
     * @param $nrInscricaoINSS
     * @param $nrInscricaoISS
     */
    public function setDadosImpostos($nrPIS, $dtPIS, $nrInscricaoINSS, $nrInscricaoISS)
    {
        $this->pessoah->setNrpispaseppes($nrPIS);
        $this->pessoah->setNrinscinsspes($nrInscricaoINSS);
        $this->pessoah->setNrinscisspes($nrInscricaoISS);

        if (!($dtPIS instanceof \DateTime)) {
            $this->pessoah->setDtinscpispasep(DateUtil::getDataDeString($dtPIS));
        }
    }

    /**
     * @param $cdEstadoCivil
     * @param $nrCertidaoCasamento
     * @param $dtCasamento
     */
    private function setDadosCivis($cdEstadoCivil, $nrCertidaoCasamento, $dtCasamento)
    {
        $this->pessoah->setCdestacivil($cdEstadoCivil);
        $this->pessoah->setNrcertcasapes($nrCertidaoCasamento);

        if (!($dtCasamento instanceof \DateTime)) {
            $this->pessoah->setDtcasapessoa(DateUtil::getDataDeString($dtCasamento));
        }
    }

    /**
     * @param $idIsentoTituloEleitor
     * @param $nrTituloEleitor
     * @param $nrSecaoEleitoral
     * @param $nrZonaEleitoral
     */
    private function setDadosEleitorais($idIsentoTituloEleitor, $nrTituloEleitor, $nrSecaoEleitoral, $nrZonaEleitoral)
    {
        $this->pessoah->setIdisentituelei($idIsentoTituloEleitor);
        $this->pessoah->setNrtitueleipes($nrTituloEleitor);
        $this->pessoah->setNrsecaeleipes($nrSecaoEleitoral);
        $this->pessoah->setNrzonaeleipes($nrZonaEleitoral);
    }

    /**
     * @param $nrHabilitacao
     * @param $dtHabilitacao
     * @param $dtValidadeHabilitacao
     * @param $categoriaHabilitacao
     */
    private function setDadosHabilitacaoVeiculo($nrHabilitacao, $dtHabilitacao, $dtValidadeHabilitacao,
                                                $categoriaHabilitacao)
    {
        $this->pessoah->setNrcarthabpes($nrHabilitacao);
        $this->pessoah->setDscateghabcart($categoriaHabilitacao);

        if (!($dtHabilitacao instanceof \DateTime)) {
            $this->pessoah->setDthabcartpes(DateUtil::getDataDeString($dtHabilitacao));
        }
        if (!($dtValidadeHabilitacao instanceof \DateTime)) {
            $this->pessoah->setDtvalhabcartpes(DateUtil::getDataDeString($dtValidadeHabilitacao));
        }
    }

    /**
     * @param $nrCategoriaMilitar
     * @param $nrCertificadoReservista
     * @param $dsCertificadoReservista
     * @param $dtCertificadoReservista
     * @param $cdExpedicaoCertificadoReservista
     */
    private function setDadosMilitares($nrCategoriaMilitar, $nrCertificadoReservista, $dsCertificadoReservista,
                                       $dtCertificadoReservista, $cdExpedicaoCertificadoReservista)
    {
        $this->pessoah->setNrcatmilitarpe($nrCategoriaMilitar);
        $this->pessoah->setNrcertresepes($nrCertificadoReservista);
        $this->pessoah->setDscategcertrese($dsCertificadoReservista);
        $this->pessoah->setCdexcertresepes($cdExpedicaoCertificadoReservista);

        if (!($dtCertificadoReservista instanceof \DateTime)) {
            $this->pessoah->setDtcertresepes(DateUtil::getDataDeString($dtCertificadoReservista));
        }
    }

    /**
     * @param $idSexo
     * @param $nrCondicaoFisica
     * @param $nrRaca
     * @param $idGrupoSanguineo
     * @param $idFatorRH
     */
    private function setDadosFisicos($idSexo, $nrCondicaoFisica, $nrRaca, $idGrupoSanguineo, $idFatorRH)
    {
        $this->pessoah->setIdsexopessoa($idSexo);
        $this->pessoah->setNrracapessoa($nrRaca);
        $this->pessoah->setNrcondfispes($nrCondicaoFisica);
        $this->pessoah->setIdgrupsangupes($idGrupoSanguineo);
        $this->pessoah->setIdfatorrhpes($idFatorRH);
    }

    /**
     * @param $nrGrauInstrucao
     */
    private function setDadosAdicionais($grauinstrucao)
    {
        $this->pessoah->setNrgrauinstr($grauinstrucao);
    }

    /**
     * @return \GpepessoaEntity
     */
    public function getPessoa()
    {
        return $this->pessoa;
    }

    /**
     * @return \GpepessoahEntity
     */
    public function getPessoah()
    {
        return $this->pessoah;
    }

    /**
     * Retorna o pronome de tratamento da pessoa
     * @param $cdEstadoCivil
     * @param $idSexoPessoa
     *
     * @return string
     *
     * @author matthaeuscarvalho
     */
    private function getPronomeTratamento($cdEstadoCivil,$idSexoPessoa){
        if ($idSexoPessoa == 'M'){
            $pronomeTratamento = 'Sr.';
            return $pronomeTratamento;
        }
        else if ($idSexoPessoa == 'F' && $cdEstadoCivil == 'C'){
            $pronomeTratamento = 'Sra.';
            return $pronomeTratamento;
        }
        else {
            $pronomeTratamento = 'Srta.';
            return $pronomeTratamento;
        }
    }
}