CREATE OR REPLACE PROCEDURE ARQUIVO_GIM_RN(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_GIM          IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_CONTADOR    VARCHAR2(10);
BEGIN
   /* CabeCalho */
   V_CONTADOR := ARQUIVO_GIM_RN_01(P_DTFINAL, P_CDINSCESTA, P_GIM, P_NRSEQARQMAG);
------------------------------------------------------------------------------------------------------------------
   /* Entradas do Estado */
   V_CONTADOR := ARQUIVO_GIM_RN_02(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Entradas de Outros Estados */
   V_CONTADOR := ARQUIVO_GIM_RN_03(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Entradas do Exterior */
   V_CONTADOR := ARQUIVO_GIM_RN_04(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Totais das Entradas */
   V_CONTADOR := ARQUIVO_GIM_RN_05(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Sadas para o Estado */
   V_CONTADOR := ARQUIVO_GIM_RN_06(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Sadas para Outro Estado */
   V_CONTADOR := ARQUIVO_GIM_RN_07(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Sadas para o Exterior */
   V_CONTADOR := ARQUIVO_GIM_RN_08(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Totais das Saidas */
   V_CONTADOR := ARQUIVO_GIM_RN_09(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Debito do Imposto */
   V_CONTADOR := ARQUIVO_GIM_RN_10(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Credito do Imposto */
   V_CONTADOR := ARQUIVO_GIM_RN_11(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Apurao dos Saldos */
   V_CONTADOR := ARQUIVO_GIM_RN_12(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* ICMS do Perodo (Normal / Substituio) */
   V_CONTADOR := ARQUIVO_GIM_RN_13(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
   /* Estoque */
   V_CONTADOR := ARQUIVO_GIM_RN_20(P_CDIMPOSTO, P_CDEMPRESA, P_CDINSCESTA, P_DTINICIAL, P_DTFINAL, P_NRSEQARQMAG,
                                   TO_NUMBER(V_CONTADOR));
------------------------------------------------------------------------------------------------------------------
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIM_RN','5.05.024'); END;
/

